/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

const LEVELS = [
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '01180001000300010001000',
        code: 'WIEDERHOLE 5 MAL\n    FALLS istBelegt DANN\n        plus\n    vor',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Er geht fünfmal ein Feld vor. Vor jedem Vorgehen legt er ein Plättchen hin, falls auf dem aktuellen Feld bereits ein Plättchen liegt. Also zwei.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 2 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '0118000100030F01000F000',
        code: 'WIEDERHOLE 6 MAL\n    FALLS istPlatz DANN\n        plus\n    vor',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Er geht sechsmal ein Feld vor. Vor jedem Vorgehen legt er ein Plättchen hin, falls auf dem aktuellen Feld noch Platz für ein weiteres Plättchen ist. Das ist nur auf einem der ersten sechs Felder nicht der Fall.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 5 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '015500000000000000000000000000000000000000000000000000220',
        code: 'WIEDERHOLE 9 MAL\n    FALLS istNorden DANN\n        plus\n    vor\n    linksrum',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Zu Beginn schaut der Roboter nach Norden, nach jeder Wiederholung dreht er sich um 90°. Nach viermal drehen blickt er also erneut nach Norden. Die Bedingung ist daher nur beim ersten, fünften und neunten Durchlauf wahr.',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 3 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    },
    {
        task: 'Beantworte die Frage, möglichst ohne das Programm vorher auszuführen. Wenn du gar nicht anders auf die Lösung kommst, kannst du das Programm vor dem Beantworten der Frage testen, das kostet aber einen Fehlerpunkt. Testen nach dem richtigen Beantworten der Frage kostet keinen Fehlerpunkt.',
        world: '015500000000000000000000000000000000000000000000000000232',
        code: 'WIEDERHOLE 10 MAL\n    FALLS istBegehbar DANN\n        plus\n        plus\n        vor\nlinksrum',
        readonly: true,
        checkCode: [
            CodeCheckers.accept(false, 1)
        ],
        questionWrongFine: 1,
        question: {
            html: 'Wie viele Plättchen legt der Roboter beim Ausführen des Programms?',
            singlechoice: true,
            keepOrder: true,
            response: 'Bei jeder Wiederholung legt er zwei Plättchen hin und geht einen Schritt vor, wenn das Vorgehen möglich ist. Das probiert er zehnmal. Aber bereits nach drei Wiederholungen ist das Feld vor ihm nicht mehr frei…',
            choices: [
                { html: "Er legt ", unit: " Plättchen", type: 'number', min: 0, step: 1, max: 99, correct: true, accept: 6 },
                { html: "Das Programm kann nicht ausgeführt werden" }
            ]
        }
    }
];

window.roboterCodingTask = {
    levels: LEVELS
};
})(window);
